%define nam	MySQL
%define ver	3.23.56
%define rel	2ml
%define srl	2003052701

%define mysqld_user mysql

# define initrd
%{!?_initrddir:%define _initrddir /etc/rc.d/init.d}

Summary: MySQL: a very fast and reliable SQL database engine
Summary(zh_CN): MySQLݿ
Name: %{nam}
Version: %{ver}
Release: %{rel}
Group: Applications/Databases
License: GPL/LGPL
Source0: http://download.souceforge.net/%{name}/mysql-%{version}.tar.gz
Source100: mysql.init
Source101: mysql.logrotate
Source102: my.cnf

Patch1: mysql_install_db.patch
Patch2: mysql-config-s390.patch
Patch3: mysql-3.23.51-readline-bufferoverflow.patch
Patch4: mysql-3.23.52-libwrap_linux.patch
Patch5: mysql-errno.patch
Patch6: mysql-3.23.54-libdir.patch
Patch7: mysql-3.23.55-libstdc++.patch
Requires: MySQL-shared = %{version}

URL: http://www.mysql.com/
Serial: %{srl}
BuildRoot: %{_tmppath}/%{name}-%{version}-root

Provides: msql , mysql, MySQL-server
Obsoletes: mysql , MySQL-server
PreReq: /sbin/install-info, /sbin/chkconfig, net-tools
BuildRequires: perl,readline-devel, ncurses-devel, zlib-devel, automake, tcp_wrappers-devel, procps
#NoSource: 0

# From the manual
%description
MySQL is a true multi-user, multi-threaded SQL (Structured Query
Language) database server. MySQL is a client/server implementation
that consists of a client programs and library files.

%package client
Summary: MySQL - Client
Summary(zh_CN): MySQL - Client 
Group: Applications/Databases
Obsoletes: mysql-client , MySQL-server
Requires: MySQL-shared = %{version}


%description client
This package contains the standard MySQL clients.

For a description of MySQL see the base MySQL RPM or http://www.mysql.com


%package bench
Release: %{rel}
Requires: MySQL-client perl
Summary: MySQL - Benchmarks
Summary(zh_CN): MySQL - Benchmarks
Group: Applications/Databases
Obsoletes: mysql-bench
Requires: MySQL-shared = %{version}

%description bench
This package contains MySQL benchmark scripts and data.

For a description of MySQL see the base MySQL RPM or http://www.mysql.com

%package devel
Release: %{rel}
Requires: MySQL-client
Summary: MySQL - Development header files and libraries
Summary(zh_CN): MySQL
Group: Applications/Databases
Obsoletes: mysql-devel
Requires: MySQL-shared = %{version}

%description devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

For a description of MySQL see the base MySQL RPM or http://www.mysql.com

%package shared
Release: %{rel}
Summary: MySQL - Shared libraries
Summary(zh_CN): MySQL 
Group: Applications/Databases
PreReq: /sbin/ldconfig
#Provides: %{name}-shared
#Obsoletes: %{name}-shared

%description shared
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MySQL.


%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n mysql-%{version}
%patch1 -p1 -b .install_db
%ifarch s390
%patch2 -p1 -b .config-s390
%endif
%patch3 -p0 -b .bo
%patch4 -p1 -b .libwrap_linux
%patch5 -p1 -b .errno
%patch6 -p1 -b .libdir
%patch7 -p1 -b .libstdc++

%build
### replace perl path
find ./ -type f | xargs perl -pi -e "s,/my/gnu/bin,/usr/bin,g"

CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE" \
CXXFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -felide-constructors -fno-exceptions -fno-rtti" \
./configure \
	--prefix=%{_prefix} \
	--exec-prefix=%{_prefix} \
	--datadir=%{_datadir} \
	--infodir=%{_infodir} \
	--mandir=%{_mandir} \
	--without-debug \
	--without-docs \
	--enable-shared \
	--with-extra-charsets=complex \
	--with-bench \
	--localstatedir=/var/lib/mysql \
	--with-unix-socket-path=/var/lib/mysql/mysql.sock \
	--with-mysqld-user=%{mysqld_user} \
        --with-extra-charsets=all \
	--with-low-memory \
	--enable-assembler \
	--with-berkeley-db \
	--with-innodb \
	--with-libwrap \
	--enable-large-files=yes \
	--enable-largefile=yes \
	--enable-local-infile \
	--with-thread-safe-client \
	--with-raid
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d
mkdir -p $RPM_BUILD_ROOT/%{_initrddir}
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/sql-bench
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/mysql-test
mkdir -p $RPM_BUILD_ROOT/%{_infodir}

make \
 DESTDIR=$RPM_BUILD_ROOT \
 pkglibdir=%{_libdir} \
 libsdir=%{_libdir} \
 benchdir_root=%{_datadir} \
install

mkdir -p $RPM_BUILD_ROOT/var/log
touch $RPM_BUILD_ROOT/var/log/mysqld.log
mkdir -p $RPM_BUILD_ROOT/var/run/mysqld

# install other stuff
install -m755  %{SOURCE100} $RPM_BUILD_ROOT%{_initrddir}/mysqld
install -m644  %{SOURCE101} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/mysql
install -m644  %{SOURCE102} $RPM_BUILD_ROOT%{_sysconfdir}/my.cnf
install -m644  Docs/mysql.info $RPM_BUILD_ROOT%{_infodir}/mysql.info

# "libodbc.a" conflicts with unixODBC
mv $RPM_BUILD_ROOT/%{_libdir}/libodbc.a $RPM_BUILD_ROOT/%{_libdir}/libmysqlodbc.a

%clean
rm -rf $RPM_BUILD_ROOT


%pre
if test -x %{_initrddir}/mysqld
then
  %{_initrddir}/mysqld stop > /dev/null 2>&1
  echo "Giving mysqld a couple of seconds to exit nicely"
  sleep 5
fi

# Create a MySQL user. Do not report any problems if it already
# exists. This is redhat specific and should be handled more portable
mysql_datadir=/var/lib/mysql
useradd -M -r -d $mysql_datadir -s /bin/bash -c "MySQL server" %{mysqld_user} 2> /dev/null || true 


%post
/sbin/install-info %{_infodir}/mysql.info* %{_infodir}/dir

mysql_datadir=/var/lib/mysql

# Create data directory if needed
if test ! -d $mysql_datadir;		then mkdir -p $mysql_datadir; fi
if test ! -d $mysql_datadir/mysql;	then mkdir $mysql_datadir/mysql; fi
if test ! -d $mysql_datadir/test;	then mkdir $mysql_datadir/test; fi

# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R %{mysqld_user} $mysql_datadir

# Initiate databases
# NOTE: Leave this line enabled otherwise the administrator will have to
# run it manually. We should only require the administrator
# to enable and start the service with turboservice or chkconfig.
mysql_install_db -IN-RPM

# Change permissions again to fix any new files.
chown -R %{mysqld_user} $mysql_datadir

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw $mysql_datadir/mysql

# Restart in the same way that mysqld will be started normally.
#%{_initrddir}/mysql start

# Allow safe_mysqld to start mysqld and print a message before we exit
#sleep 2

%preun
if test -x %{_initrddir}/mysqld; then
	%{_initrddir}/mysqld stop > /dev/null
fi
# Remove autostart of mysql
if test $1 = 0; then
  /sbin/chkconfig --del mysql
fi
/sbin/install-info --delete %{_infodir}/mysql.info* %{_infodir}/dir


%post shared -p /sbin/ldconfig

%postun shared -p /sbin/ldconfig


# We do not remove the mysql user since it may still own a lot of
# database files.

%files
%defattr(-, root, root)
%doc README COPYING COPYING.LIB Docs/manual_toc.html Docs/manual.html
%doc Docs/manual.txt Docs/manual.texi Docs/manual.ps
%doc Docs/Flags/ Docs/Support/
%doc support-files/my-huge.cnf support-files/my-large.cnf
%doc support-files/my-medium.cnf support-files/my-small.cnf

%{_bindir}/isamchk
%{_bindir}/isamlog
%{_bindir}/my_print_defaults
%{_bindir}/myisamchk
%{_bindir}/myisamlog
%{_bindir}/myisampack
%{_bindir}/mysql_convert_table_format
%{_bindir}/mysql_fix_privilege_tables
%{_bindir}/mysql_install_db
%{_bindir}/mysql_setpermission
%{_bindir}/mysql_zap
%{_bindir}/mysqlbug
%{_bindir}/mysqlcheck
%{_bindir}/mysqld_multi
%{_bindir}/mysqldumpslow
%{_bindir}/mysqlhotcopy
%{_bindir}/mysqltest
%{_bindir}/pack_isam
%{_bindir}/perror
%{_bindir}/replace
%{_bindir}/resolve_stack_dump
%{_bindir}/resolveip
%{_bindir}/safe_mysqld
%{_libexecdir}/mysqld

%{_mandir}/man1/isamchk.1*
%{_mandir}/man1/isamlog.1*
%{_mandir}/man1/mysql_zap.1*
%{_mandir}/man1/mysqld.1*
%{_mandir}/man1/mysqld_multi.1*
%{_mandir}/man1/perror.1*
%{_mandir}/man1/replace.1*
%{_mandir}/man1/safe_mysqld.1*
%{_infodir}/*.info*

%dir %{_datadir}/mysql/
%{_datadir}/mysql/*

%{_initrddir}/mysqld
%config(noreplace) %{_sysconfdir}/my.cnf
%config %{_sysconfdir}/logrotate.d/mysql
%attr(-,%{mysqld_user},root) /var/log/mysqld.log
%dir %attr(-,%{mysqld_user},%{mysqld_user}) /var/run/mysqld

%files client
%defattr(-,root,root)
%{_bindir}/msql2mysql
%{_bindir}/mysql
%{_bindir}/mysql_find_rows
%{_bindir}/mysqlaccess
%{_bindir}/mysqladmin
%{_bindir}/mysqlbinlog
%{_bindir}/mysqldump
%{_bindir}/mysqlimport
%{_bindir}/mysqlshow

%{_mandir}/man1/mysql.1*
%{_mandir}/man1/mysqlaccess.1*
%{_mandir}/man1/mysqladmin.1*
%{_mandir}/man1/mysqldump.1*
%{_mandir}/man1/mysqlshow.1*


%files devel
%defattr(-, root, root)
%{_bindir}/mysql_config
%{_bindir}/comp_err
%dir %{_includedir}/mysql
%{_includedir}/mysql/*
%{_libdir}/lib*.la
%{_libdir}/lib*.a
%{_libdir}/lib*.so

%files shared
%defattr(-, root, root)
%{_libdir}/*.so.*


%files bench
%defattr(-, root, root)
%dir %{_datadir}/sql-bench
%{_datadir}/sql-bench/*
%dir %{_datadir}/mysql-test
%{_datadir}/mysql-test/*

%changelog
* Tue May 27 2003 Atsushi Goebuchi <goebuchi@miraclelinux.com>
- 3.23.56-2ml
- add Obsoletes "MySQL-server" of "MySQL,MySQL-cliet".

* Thu Mar 27 2003 Masaru Yokoi <masaru@turbolinux.co.jp>
- 3.23.56-2
- rename pacakge name from libs to shared to be upgradable.

* Wed Mar 26 2003 Masaru Yokoi <masaru@turbolinux.co.jp>
- 3.23.56-1
- upgraded.
- modified mysql.init to close stdin

* Mon Feb 24 2003 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- 3.23.55-1
- updated to 3.23.55
- rename package name shared to libs

* Thu Dec 19 2002 Masaru Yokoi <masaru@turbolinux.co.jp>
- 3.23.52-1
- Security: mysql-3.23.52-bugfix1.patch to fix problem in client libs.

* Fri Sep 20 2002 Go Taniguchi <go@turbolinux.co.jp>
- small fixed init sripts
- added /var/run/mysqld for pid

* Mon Aug 19 2002 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to 3.23.52
- added libwrap_linux.patch
 
* Fri Jul 12 2002 Masaru Yokoi <masaru@turbolinux.co.jp>
- added mysql-3.23.51-readline-bufferoverflow.patch

* Sun Jun 16 2002 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to 3.23.51

* Fri May 3 2002 Masaru Yokoi <masaru@turbolinux.co.jp>
- added secure level in mysql.init again

* Mon Apr 29 2002 Kiichiro NAKA <knaka@turbolinux.co.jp>
- 3.23.49-4
- removed pt_BR which conflicts with zh_CN

* Thu Apr 25 2002 Kiichiro NAKA <knaka@turbolinux.co.jp>
- 3.23.49-3
- renamed a static library

* Fri Mar  8 2002 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- refixed init,my.cnf file

* Fri Mar  8 2002 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- added some useful compile option
- replace rpm macros
- split init scripts and log-rotate scripts

* Mon Jan 21 2002 Merlin Ma <merlin@turbolinux.com.cn>
- updated to version 3.23.47

* Mon Dec 03 2001 Merlin Ma <merlin@turbolinux.com.cn>
- updated to version 3.23.46

* Thu Nov  8 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to version 3.23.44

* Thu Sep 13 2001 Merlin Ma <merlin@turbolinux.com.cn>
- updated to version 3.23.42

* Tue Jul 26 2001 TAKEDA Hirofumi <takepin@turbolinux.co.jp>
- fixed runlevel at chkconfig: in init script

* Wed Jul 11 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- added security level in init script.

* Wed Jul  4 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Modified group name of MySQL-shared.

* Fri Jun 29 2001 SL Baur  <steve@turbolinux.co.jp>
- update to version 3.23.39

* Fri Jun 29 2001 SL Baur  <steve@turbolinux.co.jp>
- add net-tools to PreReq

* Wed May 23 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- changed /var/log/mysqld.log group to root

* Fri May 18 2001 Bob Frey <bfrey@turbolinux.com>
- For postinstall re-enable the install db command. Leave this line
  enabled otherwise the administrator will have to # run it manually.
  We should only require the administrator # to enable and start the
  service with turboservice or chkconfig.
- Add S390 configuration patch.

* Fri Apr 20 2001 Masaru Yokoi <masatu@turbolinux.co.jp>
- Updated to 3.23.37

* Tue Apr 16 2001 Mike Madore <mmadore@turbolinux.com>
- Added patch for missing #includes

* Fri Apr 13 2001 Simon Zhang <simonz@turbolinux.com.cn>
- Changed the GID of /var/lib/mysql.

* Mon Mar 12 2001 Hirofumi Takeda <takepin@turbolinux.co.jp>
- revivaled shared and client packages. (#2754)
- disable initiate databases in post section. (#2806)

* Tue Feb 20 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- removed shared and client packages.
- Updated to version 3.23.33

* Thu Jan 30 2001 Janez Zupan <janez@turbolinux.com>
- configure: addedd --with-low-memory

* Mon Jan 22 2001 SL Baur  <steve@turbolinux.co.jp>
- update to 3.23.31

* Sat Jan 6 2001 Roger Luethi <rluethi@turbolinux.com>
- update to 3.23.30-gamma

* Wed Jan 3 2001 Roger Luethi <rluethi@turbolinux.com>
- update from 3.23.22-beta to 3.23.29a-gamma
- libtoolized build
- removed Requires: MySQL-DBI-perl-bin for bench

* Mon Aug 21 2000 SL Baur  <steve@turbolinux.co.jp>
- update to 3.23.22
- don't run chkconfig on RPM install

* Wed Jul 12 2000 SL Baur  <steve@turbolinux.co.jp>
- fix up paths
- update to 3.23.12

* Fri Jun 30 2000 SL Baur  <steve@turbolinux.co.jp>
- de-gif
- first TurboLinux version

* Wed Sep 28 1999 David Axmark <davida@mysql.com>

- Added the support-files/my-example.cnf to the docs directory.

- Removed devel dependency on base since it is about client
  development.

* Wed Sep 8 1999 David Axmark <davida@mysql.com>

- Cleaned up some for 3.23.

* Thu Jul 1 1999 David Axmark <davida@mysql.com>

- Added support for shared libraries in a separate sub
  package. Original fix by David Fox (dsfox@cogsci.ucsd.edu)

- The --enable-assembler switch is now automatically disables on
  platforms there assembler code is unavailable. This should allow
  building this RPM on non i386 systems.

* Mon Feb 22 1999 David Axmark <david@detron.se>

- Removed unportable cc switches from the spec file. The defaults can
  now be overridden with environment variables. This feature is used
  to compile the official RPM with optimal (but compiler version
  specific) switches.

- Removed the repetitive description parts for the sub rpms. Maybe add
  again if RPM gets a multiline macro capability.

- Added support for a pt_BR translation. Translation contributed by
  Jorge Godoy <jorge@bestway.com.br>.

* Wed Nov 4 1998 David Axmark <david@detron.se>

- A lot of changes in all the rpm and install scripts. This may even
  be a working RPM :-)

* Sun Aug 16 1998 David Axmark <david@detron.se>

- A developers changelog for MySQL is available in the source RPM. And
  there is a history of major user visible changed in the Reference
  Manual.  Only RPM specific changes will be documented here.
